/*--------------------------------------------------------------------.
| menutext.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/
static char rcsid[] = "$Id: menutext.c,v 1.6 1997/11/15 14:53:16 jrh Rel $";
/*
 * $Log: menutext.c,v $
 * Revision 1.6  1997/11/15 14:53:16  jrh
 * beautifed ! menu text box
 *
 * Revision 1.5  1997/11/15 14:33:02  jrh
 * reindented for release 1.05
 *
 * Revision 1.4  1997/11/14 20:30:15  jrh
 * bidirectional menus
 *
 * Revision 1.3  1997/10/12 20:41:40  jrh
 * indented source code
 *
 * Revision 1.2  1997/10/05 19:52:37  jrh
 * Enhanced dynamic memory allocations
 *
 * Revision 1.1  1997/10/02 21:28:29  jrh
 * Initial revision
 *
 */

#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "qascade.h"

#define TEXT_MAX 72
#define PR_MAX 60

#define YSIZE 25
#define BORD_X 4

short menu_text (WM_wwork_t * wwk, char *prompt, char *rtx, int mxr)
{
    short pulld_wid, pr_wid, text_wid;
    long rcode;

    WM_wstat_t *ws;
    WM_wwork_t *ww;
    WM_info_t *info;
    WM_infw_t *infw;
    QD_text_t *qprompt, *qtext;

    ws = xalloc (sizeof (WM_wstat_t) + sizeof (WM_wwork_t) +
		 2 * sizeof (WM_info_t) + 4 * sizeof (WM_infw_t) +
		 4 + TEXT_MAX + PR_MAX);

    info = (WM_info_t *) (ws + 1);
    infw = (WM_infw_t *) (info + 2);
    ww = (WM_wwork_t *) (infw + 4);
    qprompt = (QD_text_t *) (ww + 1);
    qtext = (QD_text_t *) ((char *) qprompt + sizeof (short) + PR_MAX);

    qprompt->len = strlen (prompt);
    strcpy ((char *) qprompt->chrs, prompt);

    if (mxr > TEXT_MAX)
	mxr = TEXT_MAX;
    qtext->len = strlen (rtx);
    if (qtext->len > mxr)
	qtext->len = mxr;
    strncpy ((char *) qtext->chrs, rtx, mxr);

    pulld_wid = text_wid = mxr * 6;	/* first guess at width */

    pr_wid = (qprompt->len + 1) * 6;
    if (pr_wid > pulld_wid)
	pulld_wid = pr_wid;

    if (pr_wid > wwk->xsize)
	pr_wid = wwk->xsize - 6;
    if (pulld_wid > wwk->xsize)
	pulld_wid = wwk->xsize - 6;
    if (text_wid > wwk->xsize)
	text_wid = wwk->xsize - 6;

    (info + 0)->xsize = pr_wid - 6;	/* size and position of */
    (info + 0)->ysize = 10;
    (info + 0)->xorg = 2;
    (info + 0)->type = TYP_TEXT;
    (info + 0)->pobj = qprompt;
    (info + 1)->xsize = -1;

    (infw + 0)->xsize = pulld_wid + BORD_X;	/* size of title window */
    (infw + 0)->ysize = 10;
    (infw + 0)->xorg = BORD_X/2;
    (infw + 0)->yorg = 1;
    (infw + 0)->borw = 0;
    (infw + 0)->borc = 0;
    (infw + 0)->papr = 84;

    (infw + 1)->xsize = pr_wid; 	/* size of title window */
    (infw + 1)->ysize = 10;
    (infw + 1)->xorg = (pulld_wid - pr_wid) / 2;
    (infw + 1)->yorg = 1;
    (infw + 1)->borw = 0;
    (infw + 1)->borc = 0;
    (infw + 1)->papr = CL_MBACK;
    (infw + 1)->pobl = info;

    (infw + 2)->xsize = text_wid;
    (infw + 2)->ysize = 10;
    (infw + 2)->xorg = (pulld_wid - text_wid) / 2 + BORD_X;
    (infw + 2)->yorg = 13;
    (infw + 2)->flag = 0;
    (infw + 2)->borw = 1;
    (infw + 2)->borc = 0;
    (infw + 2)->papr = CL_MBACK;

    (infw + 3)->xsize = -1;

    ww->xsize = pulld_wid + BORD_X * 2;
    ww->ysize = YSIZE;
    ww->xorg = (infw + 1)->xorg - 2;
    ww->yorg = (infw + 1)->yorg + 8;	/* text near pointer */
    ww->flag = 2;
    ww->borw = 1;
    ww->borc = CL_MBORD;
    ww->papr = CL_MBACK;
    ww->curw = 1;
    ww->curc = CL_MHIGH;
    ww->uback = CL_MPUNAV;
    ww->uink = CL_MIUNAV;
    ww->aback = CL_MPAVBL;
    ww->aink = CL_MIAVBL;
    ww->sback = CL_MPSLCT;
    ww->sink = CL_MISLCT;
    ww->ninfo = 3;
    ww->ninob = 1;
    ww->pinfo = infw;
    ws->wwork = ww;
    ww->wstat = ws;
    ws->citem = -1;
    ws->ciact = NULL;
    ws->wmode = FORM_QL4;

    wm_pulld (ww, wwk->wstat->ptpsx, wwk->wstat->ptpsy-13);	/* pull down */
    wm_wdraw (ww);

    wm_swinf (ww, (short) 2, 0);

    rcode = wm_rname (ww->chid, qtext);

    wm_cluns (ww);
    if (rcode)
    {
	rcode = -1;
    }
    else
    {
	strncpy (rtx, (char *) qtext->chrs, qtext->len);
	*(rtx + qtext->len) = '\0';
	rcode = qtext->len;
    }
    xfree (ws);
    return rcode;
}
